---
title: Documentation
root: ..
---
* User documentation can be found at our [Ethereum User Guide and reference manual](http://ethereum.gitbooks.io/frontier-guide/content/).
* For the API reference and developer documentation head over to the auto generated [GoDoc](https://godoc.org/github.com/ethereum/go-ethereum) documentation.

This is the documentation for the official Ethereum golang implementation. For generic Ethereum-related information (whitepaper, yellow paper, protocol and interface specs, APIs, DAPP development guides, etc) see the [Ethereum main wiki](https://github.com/ethereum/wiki/wiki).

Main entry points:

* [Installation Instructions](./install-and-build/installing-geth)
* [Management APIs](./interface/management-apis)
* [Managing Accounts](./interface/managing-your-accounts)
* [Command Line Options](./interface/command-line-options)
* [JavaScript Console](./interface/javascript-console)
* [Private Network](./doc/private-network)
* [Developers' Guide](./install-and-build/developers-guide)
* [Whisper v6](./whisper/whisper-overview)

Sidebar lists all pages.
